package cn.com.tenlion.systembase.service.enterprise;

import cn.com.tenlion.systembase.pojo.bos.enterprise.EnterpriseBO;
import cn.com.tenlion.systembase.pojo.dtos.enterprise.EnterpriseDTO;
import cn.com.tenlion.systembase.pojo.pos.enterprise.EnterprisePO;
import cn.com.tenlion.systembase.pojo.vos.enterprise.EnterpriseVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IEnterpriseService
 * @Description: 非公有制经济组织
 * @Author: CodeFactory
 * @Date: 2021-11-04 15:22:05
 * @Version: 3.0
 **/
public interface IEnterpriseService {

    /**
     * 新增非公有制经济组织
     *
     * @param enterpriseVO
     * @return
     */
    void save(EnterpriseVO enterpriseVO);

    /**
     * 新增非公有制经济组织
     *
     * @param token
     * @param enterpriseVO
     * @return
     */
    void save(String token, EnterpriseVO enterpriseVO);

    /**
     * 新增非公有制经济组织
     *
     * @param enterpriseVO
     * @return enterpriseId
     */
    String saveReturnId(EnterpriseVO enterpriseVO);

    /**
     * 新增非公有制经济组织
     *
     * @param token
     * @param enterpriseVO
     * @return enterpriseId
     */
    String saveReturnId(String token, EnterpriseVO enterpriseVO);

    /**
     * 删除非公有制经济组织
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids, String idsStr);


    /**
     * 删除非公有制经济组织
     *
     * @param token
     * @param ids   id列表
     * @return
     */
    void remove(String token, List<String> ids, String idsStr);

    /**
     * 删除非公有制经济组织（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改非公有制经济组织
     *
     * @param enterpriseId
     * @param enterpriseVO
     * @return
     */
    void update(String enterpriseId, EnterpriseVO enterpriseVO);

    /**
     * 修改非公有制经济组织
     *
     * @param token
     * @param enterpriseId
     * @param enterpriseVO
     * @return
     */
    void update(String token, String enterpriseId, EnterpriseVO enterpriseVO);

    /**
     * 非公有制经济组织详情
     *
     * @param params 参数Map
     * @return
     */
    EnterpriseDTO get(Map<String, Object> params);

    /**
     * 非公有制经济组织详情
     *
     * @param enterpriseId
     * @return
     */
    EnterpriseDTO get(String enterpriseId);

    /**
     * 非公有制经济组织详情
     *
     * @param params 参数Map
     * @return
     */
    EnterpriseBO getBO(Map<String, Object> params);

    /**
     * 非公有制经济组织详情
     *
     * @param enterpriseId
     * @return
     */
    EnterpriseBO getBO(String enterpriseId);

    /**
     * 非公有制经济组织详情
     *
     * @param params 参数Map
     * @return
     */
    EnterprisePO getPO(Map<String, Object> params);

    /**
     * 非公有制经济组织详情
     *
     * @param enterpriseId
     * @return
     */
    EnterprisePO getPO(String enterpriseId);

    /**
     * 非公有制经济组织详情
     *
     * @param businessRegNo
     * @return
     */
    EnterprisePO getPOByBusinessRegNo(String businessRegNo);

    /**
     * 非公有制经济组织列表
     *
     * @param params
     * @return
     */
    List<EnterpriseDTO> list(Map<String, Object> params);

    /**
     * 非公有制经济组织列表
     *
     * @param params
     * @return
     */
    List<EnterpriseBO> listBO(Map<String, Object> params);

    /**
     * 非公有制经济组织列表
     *
     * @param params
     * @return
     */
    List<EnterprisePO> listPO(Map<String, Object> params);

    /**
     * 非公有制经济组织分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<EnterpriseDTO>> listPage(ListPage page);

    /**
     * 非公有制经济组织统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    void saveKafka(String uid, EnterpriseVO enterpriseVO);

    void updateKafka(String uid, EnterpriseVO enterpriseVO);

    void deleteKafka(String uid);

}